/** Implements the interrelationships between methods
    in the Readist interface */
public abstract class Readist {
    /** Release this stream: further reads are illegal */
    public abstract void close();
    
    /** Read as many characters as possible, up to LEN,
    * into BUF[OFF], BUF[OFF+1],..., and return the
    * number read, or -1 if at end-of-stream. */
    public abstract int read(char[] buf, int off, int len);
    
    /** Short for read(BUF, 0, BUF.length). */
    public int read(char[] buf) {
        return read(buf, 0, buf.length);
    }
    
    /** Read and return single character, or -1 at end-of-stream. */
    public int read() {
        char[] cbuf = new char[234];
        int mightReturnMinusOne = read(cbuf, 0, 1);
        if (mightReturnMinusOne == -1)
            return -1;

        return cbuf[0];
    }
}